#include "ulamek.h"
#include<sstream>


ulamek::ulamek()
{
	mianownik = 1;
	licznik = 0;
}

ulamek::ulamek(int n)
{
	licznik = n;
	mianownik = 1;
}
ulamek::ulamek(int licznik, int mianownik)
{
	if (mianownik != 0)
	{
		int dzielnik = nwd(licznik, mianownik);
		if (dzielnik > 1)
		{
			this->licznik = licznik / dzielnik;
			this->mianownik = mianownik / dzielnik;
		}
		else
		{
			this->mianownik = mianownik;
			this->licznik = licznik;
		}

	}
	else
		throw "Mianownik rowny zero!";


}
ulamek::~ulamek()
{
}

std::string ulamek::toString()
{
	//std::ostringstream s; // strumien acuchowy
	//s << licznik;
	//s << '/';
	//s << mianownik;
	//
	//return s.str();

	if (licznik == 0)
		return "0";
	if (mianownik == 1)
		return std::to_string(licznik);
	std::string s{};
	s = std::to_string(licznik);
	s += '/';
	s += std::to_string(mianownik);
	return s;
}

int ulamek::nwd(int a, int b)
{
	do
	{
		if (a>b) a = a - b;
		else b = b - a;
	} while (a != b);
	return a;
}

ulamek ulamek::dodaj(ulamek u)
{
	return ulamek(this->licznik*u.mianownik+this->mianownik*u.licznik, this->mianownik*u.mianownik);
}
ulamek ulamek::operator + (ulamek u)
{
	return this->dodaj(u);
}

ulamek ulamek::operator * (ulamek u)
{
	return ulamek(u.licznik*licznik, u.mianownik*mianownik);
}
ulamek ulamek::operator / (ulamek u)
{
	return  ulamek(licznik*u.mianownik, mianownik*u.licznik);
}